%define tcltk_major	8.3
%define tclx_major	8.3
%define expect_major	5.38
%define tix_major	8.1
%define itcl_major	3.2
%define tcllib_major	1.3

%define tcltkvers	%{tcltk_major}.5
%define tclxvers	%{tclx_major}
%define expvers		%{expect_major}.0
%define tixvers		%{tix_major}.4
%define itclvers	%{itcl_major}
%define tcllibvers	%{tcllib_major}

Summary: A Tcl/Tk development environment: tcl, tk, tix, tclX, expect, and itcl.
Name: tcltk
Version: %{tcltkvers}
# NB release number can only be reset if *all* versions go up!
Release: 92.2
Source0: ftp://tcl.activestate.com/pub/tcl/tcl8_3/tcl%{tcltkvers}.tar.gz
Source1: ftp://tcl.activestate.com/pub/tcl/tcl8_3/tk%{tcltkvers}.tar.gz
Source2: http://expect.nist.gov/src/expect-%{expvers}.tar.bz2
Source3: ftp://tcl.activestate.com/pub/tcl/tclx/tclx%{tclxvers}.tar.bz2
Source4: http://tix.sourceforge.net/dist/tix-%{tixvers}.tar.gz
Source5: http://prdownloads.sourceforge.net/incrtcl/itcl%{itclvers}.tar.bz2
Source6: http://prdownloads.sourceforge.net/tcllib/tcllib-%{tcllibvers}.tar.gz
Source7: http://prdownloads.sourceforge.net/tcl/tcl%{tcltkvers}.html.tar.gz
Source20: tix-8.1.4-pkgIndex-datadir-83662.patch
Patch1: tcl-8.3.3-heiierarchy.patch
Patch4: tcl-8.3.3-dlopen.patch
Patch5: tcl-8.3.5-tclm4-soname.patch
Patch6: tcl-8.3.5-lib-perm.patch
Patch7: tcltk-8.3.5-ucs4-for-py.patch
Patch8: tcl8.3.5-koi8-u.enc-88806.patch
Patch9: tcl8.3.5-tclConfig-package-path-90160.patch
Patch50: tk-8.3.5-tclm4-soname.patch
Patch51: tk-8.3.5-lib-perm.patch
Patch110: expect-5.32.2-random.patch
Patch111: expect-5.32.2-64bit.patch
Patch112: expect-5.32.2-kibitz.patch
Patch113: expect-5.32.2-fixcat.patch
Patch114: expect-5.32.2-weather.patch
Patch116: expect-5.38.0-spawn-43310.patch
Patch117: expect-5.32.2-expectk.patch
Patch118: expect-5.32.2-setpgrp.patch
Patch119: expect-5.38.0-autopasswd-9917.patch
Patch120: expect-5.38.0-lib-spec.patch
Patch121: expect-5.39.0-libdir.patch
Patch122: expect-ro-afs-112174.patch
Patch123: expect-5.38-free-segfault-58317.patch
Patch20: tix-8.1.4-install-pkgIndex-datadir-83662.patch
#Patch23: tix-8.1.3-itcl321.patch
Patch32: itcl-3.2-ac-wish.patch
Patch33: itcl-3.2-iwidgets-symlink.patch
Patch34: itcl3.2-tclstubs-cfg.patch
Patch41: tclx-8.3-argv.patch
Patch42: tclx-8.3-varinit.patch
Patch43: tclx-8.3-nonstrip.patch
Patch44: tclx-8.3-helpdir.patch
Patch60: tcllib-1.3-cfg-tclcfg.patch
BuildRequires: util-linux perl XFree86-devel autoconf213
License: BSD
Group: Development/Languages
Buildroot: %{_tmppath}/%{name}-%{tcltkvers}

%description
Tcl is a simple scripting language designed to be embedded into other
applications.  Tcl is designed to be used with Tk, a widget set.

%package -n tcl
Version: %{tcltkvers}
Summary: Tcl scripting language development environment
Group: Development/Languages
URL: http://tcl.sourceforge.net/

%description -n tcl
The Tcl (Tool Command Language) provides a powerful platform for creating
integration applications that tie together diverse applications, protocols,
devices, and frameworks. Tcl can also be used for a variety of web-related
tasks and for creating powerful command languages for applications.

%package -n tcl-devel
Version: %{tcltkvers}
Summary: Tcl scripting language development environment
Group: Development/Languages
URL: http://tcl.sourceforge.net/
Requires: tcl = %{tcltkvers}-%{release}

%description -n tcl-devel
The Tcl (Tool Command Language) provides a powerful platform for creating
integration applications that tie together diverse applications, protocols,
devices, and frameworks. Tcl can also be used for a variety of web-related
tasks and for creating powerful command languages for applications.

The package contains the development files and man pages for tcl.

%package -n tk
Version: %{tcltkvers}
Summary: Tk graphical toolkit for the Tcl scripting language
Group: Development/Languages
URL: http://tcl.sourceforge.net/
Requires: tcl XFree86-libs

%description -n tk
When paired with the Tcl scripting language, Tk provides a fast and powerful
way to create GUI applications that run on Linux as well as Windows, Unix,
and the Macintosh.

%package -n tk-devel
Version: %{tcltkvers}
Summary: Tk graphical toolkit for the Tcl scripting language
Group: Development/Languages
URL: http://tcl.sourceforge.net/
Requires: tk = %{tcltkvers}-%{release}
Requires: XFree86-devel

%description -n tk-devel
When paired with the Tcl scripting language, Tk provides a fast and powerful
way to create GUI applications that run on Linux as well as Windows, Unix,
and the Macintosh.

The package contains the development files and man pages for tk.

%package -n expect
Version: %{expvers}
Summary: A program-script interaction and testing utility
Group: Development/Languages
License: Public Domain
URL: http://expect.nist.gov/
Requires: tcl

%description -n expect
Expect is a tcl application for automating and testing
interactive applications such as telnet, ftp, passwd, fsck,
rlogin, tip, etc. Expect makes it easy for a script to
control another program and interact with it.

This package contains expect and some scripts that use it.

%package -n expect-devel
Version: %{expvers}
Summary: A program-script interaction and testing utility
Group: Development/Languages
License: Public Domain
URL: http://expect.nist.gov/
Requires: expect = %{expvers}-%{release}

%description -n expect-devel
Expect is a tcl application for automating and testing
interactive applications such as telnet, ftp, passwd, fsck,
rlogin, tip, etc. Expect makes it easy for a script to
control another program and interact with it.

This package contains development files for the expect library.

%package -n expectk
Version: %{expvers}
Summary: A program-script interaction and testing utility
Group: Development/Languages
License: Public Domain
URL: http://expect.nist.gov/
Requires: expect = %{expvers} tcl tk

%description -n expectk
Expect is a tcl application for automating and testing
interactive applications such as telnet, ftp, passwd, fsck,
rlogin, tip, etc. Expect makes it easy for a script to
control another program and interact with it.

This package contains expectk and some scripts that use it.

%package -n tclx
Version: %{tclxvers}
Summary: Extensions for Tcl and Tk
Group: Development/Languages
URL: http://tclx.sourceforge.net/

%description -n tclx
Extended Tcl (TclX) is a set of extensions to the Tcl programming language.
Extended Tcl is oriented towards system programming tasks and large
application development.  TclX provides additional interfaces to the
operating system, and adds new programming constructs, text manipulation
and debugging tools.

%package -n tix
Version: %{tixvers}
Epoch: 1
Summary: A set of extension widgets for Tk
Group: Development/Languages
URL: http://tix.sourceforge.net/
Requires: tcl tk itcl

%description -n tix
Tix (Tk Interface Extension), an add-on for the Tk widget set, is an
extensive set of over 40 widgets.  In general, Tix widgets are more
complex and more capable than the widgets provided in Tk.  Tix widgets
include a ComboBox, a Motif-style FileSelectBox, an MS Windows-style
FileSelectBox, a PanedWindow, a NoteBook, a hierarchical list, a
directory tree and a file manager.

%package -n itcl
Version: %{itclvers}
Summary: Tcl object-oriented extensions
Group: Development/Languages
URL: http://incrtcl.sourceforge.net/
Requires: tk

%description -n itcl
[incr Tcl] is an object-oriented extension of the Tcl language.  It was
created to support more structured programming in Tcl.  Tcl scripts that
grow beyond a few thousand lines become extremely difficult to maintain.
This is because the building blocks of vanilla Tcl are procedures and global
variables, and all of these building blocks must reside in a single global
namespace.  There is no support for protection or encapsulation.

%package -n tcllib
Version: %{tcllibvers}
Summary: Tcl Standard Library
Group: Development/Libraries
URL: http://tcllib.sourceforge.net/
Requires: tcl

%description -n tcllib
Tcllib is a collection of utility modules for Tcl. These modules provide a wide
variety of functionality, from implementations of standard data structures to
implementations of common networking protocols. The intent is to collect
commonly used function into a single library, which users can rely on to be
available and stable. 

%package -n tcl-html
Version: %{tcltkvers}
Summary: Tcl/Tk manual in html format
Group: Development/Libraries
URL: http://tcl.sourceforge.net/

%description -n tcl-html
Tcl/Tk is a powerful scripting language and GUI toolkit.
The package contains the html manual.

%define tcltktop	%{_builddir}/%{name}-%{tcltkvers}

%prep
%setup -q -c -a 1 -a 2 -a 3 -a 4 -a 5 -a 6 -a 7

cd %{tcltktop}/tcl%{tcltkvers}
%patch1 -p1 -b .heiiearchy
%patch4 -p1 -b .dlopen
%patch5 -p1 -b .soname
%patch6 -p1 -b .mod555
#%%patch7 -p1 -b .ucs4
%patch8 -p1 -b .space
%patch9 -p1 -b .pkgpath
# patch5 touches tcl.m4 and patch9 touches configure.in
cd unix
autoconf-2.13

cd %{tcltktop}/tk%{tcltkvers}
%patch50 -p1 -b .soname
%patch51 -p1 -b .mod_555
# tk-8.3.5 configure seems broken
# patch 50 touches tcl.m4
cd unix
autoconf-2.13

cd %{tcltktop}/expect-%{expect_major}
%patch110 -p1 -b .random
%patch111 -p1 -b .64bit
%patch112 -p1 -b .kibitz
%patch113 -p1 -b .fixcat
%patch114 -p1 -b .weather
%patch116 -p2 -b .spawn
%patch117 -p1 -b .expectk
%patch118 -p2 -b .pgrp
%patch119 -p1 -b .hyphen
%patch120 -p1 -b .local-libdir
%patch121 -p1 -b .libdir
%patch122 -p2 -b .ro-afs
%patch123 -p0 -b .free
# patch120 and patch122 touch configure.in
autoconf-2.13

cd %{tcltktop}/itcl%{itclvers}
%patch32 -p1 -b .wish
%patch33 -p1 -b .symlink
%patch34 -p1 -b .stubs
# itcl3.2's configure files are user read-only
# # 3.2.1 itcl configure is out of date
# patch34 touches configure.in
(cd itcl ; chmod u+w configure ; autoconf-2.13)
# # 3.2.1 itk configure is out of date
# patch32 touches tcl.m4 and patch34 touches configure.in
(cd itk ; chmod u+w configure ; autoconf-2.13)

cd %{tcltktop}/tix-%{tixvers}
%patch20 -p1 -b .pkgIndex
#%patch23 -p1 -b .itcl321
#( cd unix/itcl3.2 ;
#  autoconf-2.13 )

cd %{tcltktop}/tclx%{tclx_major}
%patch44 -p1 -b .help
%patch41 -p1 -b .argv
%patch42 -p1 -b .varinit
%patch43 -p1 -b .nonstrip

cd %{tcltktop}/tcllib-%{tcllibvers}
%patch60 -p1 -b .tclconfig
autoconf-2.13

%build
# run "make check" by default
%{?_without_check: %define _without_check 1}
%{!?_without_check: %define _without_check 0}

%define _make make %{?_smp_mflags}
#------------------------------------------
# Tcl
#
cd %{tcltktop}/tcl%{tcltkvers}/unix
%configure --enable-gcc --enable-64bit
%_make TCL_LIBRARY=%{_datadir}/tcl%{tcltk_major}
#%if ! %{_without_check}
#  %_make test
#%endif

#------------------------------------------
# Tk
#
cd %{tcltktop}/tk%{tcltkvers}/unix
%configure --enable-gcc --with-tcl=%{tcltktop}/tcl%{tcltkvers}/unix --enable-64bit --with-x
%_make TK_LIBRARY=%{_datadir}/tk%{tcltk_major}

#------------------------------------------
# tclX
#
cd %{tcltktop}/tclx%{tclx_major}/unix
# --with-help=%{tcltktop}/tclx%{tclx_major} 
%configure --enable-tk=YES --with-tcl=%{tcltktop}/tcl%{tcltkvers}/unix --with-tk=%{tcltktop}/tk%{tcltkvers}/unix --enable-gcc --enable-64bit
#make CFLAGS="-O2 -fPIC"
# smp building doesn't work
make TCLX_INST_RUNTIME=%{_datadir}/tclX%{tclx_major} TKX_INST_RUNTIME=%{_datadir}/tkX%{tclx_major} TCLX_EXEC_RUNTIME=%{_libdir}/tclX%{tclx_major} TKX_EXEC_RUNTIME=%{_libdir}/tkX%{tclx_major}
#%_make test
#%_make tktest

#------------------------------------------
# Expect
#
cd %{tcltktop}/expect-%{expect_major}
#chmod u+w testsuite/configure
%configure --with-tcl=%{tcltktop}/tcl%{tcltkvers}/unix --with-tk=%{tcltktop}/tk%{tcltkvers}/unix --with-tclinclude=%{tcltktop}/tcl%{tcltkvers}/generic --enable-shared --with-x=yes --with-tkinclude=%{tcltktop}/tk%{tcltkvers}/generic --enable-gcc
make

#------------------------------------------
# Itcl
#
cd %{tcltktop}/itcl%{itclvers}
%configure --with-tcl=%{tcltktop}/tcl%{tcltkvers}/unix --with-tk=%{tcltktop}/tk%{tcltkvers}/unix --enable-gcc --enable-shared
%_make ITCL_LIBRARY=%{_datadir}/itcl%{itcl_major} ITK_LIBRARY=%{_datadir}/itk%{itcl_major} TCL_STUB_LIB_SPEC="-L%{tcltktop}/tcl%{tcltkvers}/unix -ltclstub%{tcltk_major}"

#------------------------------------------
# Tix
#
cd %{tcltktop}/tix-%{tixvers}/unix
%configure --with-tcl=%{tcltktop}/tcl%{tcltkvers}/unix --with-tk=%{tcltktop}/tk%{tcltkvers}/unix --enable-gcc
( cd tk%{tcltk_major}; 
  patch -b --suffix .datadir < %SOURCE20
  %configure --enable-shared )
( cd itcl%{itcl_major}; 
  patch -b --suffix .datadir < %SOURCE20
  %configure --with-itcl=%{tcltktop}/itcl%{itclvers} --enable-shared )
%_make all

#------------------------------------------
# tcllib
#
cd %{tcltktop}/tcllib-%{tcllibvers}
%configure --with-tcl=%{tcltktop}/tcl%{tcltkvers}/unix
# tweak path for tclsh needed by "make doc-html"
%_make PATH=%{tcltktop}/tcl%{tcltkvers}/unix:$PATH LD_LIBRARY_PATH=%{tcltktop}/tcl%{tcltkvers}/unix: pkglibdir=%{_datadir}/tcllib%{tcllib_major}
#%_make TCL_LIBRARY=%{tcltktop}/tcl%{tcltkvers}/library PATH=%{tcltktop}/tcl%{tcltkvers}/unix:$PATH LD_LIBRARY_PATH=%{tcltktop}/tcl%{tcltkvers}/unix: pkglibdir=%{_datadir}/tcllib%{tcllib_major}

#==========================================

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}
rm -f *.files

%define _genfilelist() ( echo "%%defattr(-,root,root)" > %1 ; find %{buildroot}%{_bindir} %{buildroot}%{_datadir} %{buildroot}%{_includedir} %{buildroot}%{_libdir} -mindepth 1 \\( -type d -printf "%%%%dir %%p\\n" \\) -o -print | cat - *.files | sort | uniq -u >> %1 )

export LD_LIBRARY_PATH=%{buildroot}%{_libdir}
#------------------------------------------
# Tcl
#
make install -C %{tcltktop}/tcl%{tcltkvers}/unix INSTALL_ROOT=%{buildroot} TCL_LIBRARY=%{_datadir}/tcl%{tcltk_major}

ln -s tclsh%{tcltk_major} %{buildroot}%{_bindir}/tclsh

# for linking with -ltcl
ln -s libtcl%{tcltk_major}.so %{buildroot}%{_libdir}/libtcl.so

# backward compatible symlink for legacy tcl packages that hardcode lib path
# to prefix/lib/%{name}%{tcltk_major}
## make /usr/lib for multilib archs
mkdir -p %{buildroot}%{_prefix}/lib
ln -s %{_datadir}/tcl%{tcltk_major} %{buildroot}%{_prefix}/lib/tcl%{tcltk_major}

cat << EOF > tcl.files
%%defattr(-,root,root)
%{buildroot}%{_bindir}/tclsh
%{buildroot}%{_bindir}/tclsh%{tcltk_major}
%{buildroot}%{_libdir}/libtcl%{tcltk_major}.so
%{buildroot}%{_libdir}/tclConfig.sh
%{buildroot}%{_prefix}/lib/tcl%{tcltk_major}
%{buildroot}%{_mandir}/man1/tclsh.1
EOF

find %{buildroot}%{_datadir}/tcl%{tcltk_major} \( -type d -printf "%%%%dir %%p\\n" \) -o -print >> tcl.files

%_genfilelist tcl-devel.files

#------------------------------------------
# Tk
#
make install -C %{tcltktop}/tk%{tcltkvers}/unix INSTALL_ROOT=%{buildroot} TK_LIBRARY=%{_datadir}/tk%{tcltk_major}

ln -s wish%{tcltk_major} %{buildroot}%{_bindir}/wish

# for linking with -ltk
ln -s libtk%{tcltk_major}.so %{buildroot}%{_libdir}/libtk.so

# backward compatible symlink for legacy tcl packages that hardcode lib path
# to prefix/lib/%{name}%{tcltk_major}
ln -s %{_datadir}/tk%{tcltk_major} %{buildroot}%{_prefix}/lib/tk%{tcltk_major}

cat << EOF > tk.files
%%defattr(-,root,root)
%{buildroot}%{_bindir}/wish
%{buildroot}%{_bindir}/wish%{tcltk_major}
%{buildroot}%{_libdir}/libtk%{tcltk_major}.so
%{buildroot}%{_libdir}/tkConfig.sh
%{buildroot}%{_prefix}/lib/tk%{tcltk_major}
%{buildroot}%{_mandir}/man1/wish.1
EOF

find %{buildroot}%{_datadir}/tk%{tcltk_major} \( -type d -printf "%%%%dir %%p\\n" \) -o -print >> tk.files

%_genfilelist tk-devel.files

#------------------------------------------
# TclX
#
make install -C %{tcltktop}/tclx%{tclxvers}/unix INSTALL_ROOT=%{buildroot} TCLX_INST_LIB=%{_libdir} TKX_INST_LIB=%{_libdir} TCLX_INST_RUNTIME=%{_datadir}/tclX%{tclx_major} TKX_INST_RUNTIME=%{_datadir}/tkX%{tclx_major} TCLX_EXEC_RUNTIME=%{_libdir}/tclX%{tclx_major} TKX_EXEC_RUNTIME=%{_libdir}/tkX%{tclx_major} TCLX_INST_MAN=%{_mandir}

# for linking with -ltclx
ln -s libtclx%{tclx_major}.so %{buildroot}%{_libdir}/libtclx.so

%_genfilelist tclx.files

#------------------------------------------
# Expect
#
make install -C %{tcltktop}/expect-%{expect_major} INSTALL_ROOT=%{buildroot} TCLLIB_INSTALLED="-L%{buildroot}%{_libdir} -ltcl%{tcltk_major}" TKLIB_INSTALLED="-L%{buildroot}%{_libdir} -ltk%{tcltk_major}"

# for linking with -lexpect
ln -s libexpect%{expect_major}.so %{buildroot}%{_libdir}/libexpect.so

# remove cryptdir/decryptdir, as Linux has no crypt command (bug 6668).
rm -f %{buildroot}%{_bindir}/{cryptdir,decryptdir}
rm -f %{buildroot}%{_mandir}/man1/{cryptdir,decryptdir}.1*

echo "%%defattr(-,root,root)" > expectk.files
echo %{buildroot}%{_bindir}/expectk >> expectk.files
echo %{buildroot}%{_mandir}/man1/expectk.1 >> expectk.files
set +x
for n in %{buildroot}%{_bindir}/* ; do
	if head -1 $n | grep -q %{_bindir}/expectk ; then
	   echo $n >> expectk.files
	   if [ -f %{buildroot}%{_mandir}/man1/`basename $n`.1 ]; then
	      echo %{buildroot}%{_mandir}/man1/`basename $n`.1 >> expectk.files
	   fi
	fi
done
set -x

cat > expect-devel.files << EOF
%%defattr(-,root,root)
%{buildroot}%{_libdir}/expect%{expect_major}/libexpect%{expect_major}.a
%{buildroot}%{_libdir}/libexpect%{expect_major}.a
%{buildroot}%{_mandir}/man3/libexpect.3
%{buildroot}%{_includedir}/expect.h
%{buildroot}%{_includedir}/expect_comm.h
%{buildroot}%{_includedir}/expect_tcl.h
%{buildroot}%{_includedir}/tcldbg.h
EOF

%_genfilelist expect.files

set +x +H
for n in `cat expect*.files`; do
	test -f $n || continue
	head -1 $n | grep -q ^#! || continue
	chmod u+w $n
	perl -pi -e "s|%{buildroot}||" $n
done
set -x -H

#------------------------------------------
# Tix
#
%makeinstall -C %{tcltktop}/tix-%{tixvers}/unix LIB_DIR=%{buildroot}%{_libdir} MAN_DIR=%{buildroot}%{_mandir} TIX_LIBRARY=%{buildroot}%{_datadir}/tix%{tix_major}

# for linking with -ltix
ln -s libtix%{tix_major}.%{tcltk_major}.so %{buildroot}%{_libdir}/libtix.so

# XXX set execute bits on library so that requires are generated.
chmod +x %{buildroot}%{_libdir}/libtix*.so

%_genfilelist tix.files

# ship docs except pdf
rm -rf %{tcltktop}/tix-%{tixvers}/docs/pdf
find %{tcltktop}/tix-%{tixvers}/docs -name .cvsignore -exec rm '{}' ';'
echo "%%doc tix-%{tixvers}/docs" >> tix.files

#------------------------------------------
# Itcl
#
%makeinstall -C %{tcltktop}/itcl%{itclvers} TCL_LIBRARY=%{buildroot}%{_datadir}/tcl%{tcltk_major} ITCL_LIBRARY=%{buildroot}%{_datadir}/itcl%{itcl_major} ITK_LIBRARY=%{buildroot}%{_datadir}/itk%{itcl_major} SCRIPT_INSTALL_DIR=%{buildroot}%{_datadir}/iwidgets\${VERSION} LIB_INSTALL_DIR=%{buildroot}%{_datadir} MAN_INSTALL_DIR=%{buildroot}%{_mandir} TCL_LIB_SPEC="-L%buildroot%{_libdir} -ltcl" TCL_STUB_LIB_SPEC="-L%buildroot%{_libdir} -ltclstub%{tcltk_major}"

# for linking with -litcl and -litk
ln -s libitcl%{itcl_major}.so %{buildroot}%{_libdir}/libitcl.so
ln -s libitk%{itcl_major}.so %{buildroot}%{_libdir}/libitk.so

%_genfilelist itcl.files

set +x +H
for n in `cat itcl.files`; do
	[ -f $n ] || continue
	head -1 $n | grep -q ^#! || continue
	chmod u+w $n
	perl -pi -e "s|%{buildroot}||" $n
done
set -x -H

#------------------------------------------
# Tcllib
#
make install -C %{tcltktop}/tcllib-%{tcllibvers} INSTALL_ROOT=%{buildroot} TCL_LIBRARY=%{buildroot}%{_datadir}/tcl%{tcltk_major} pkglibdir=%{buildroot}%{_datadir}/tcllib%{tcllib_major}

%_genfilelist tcllib.files

# remove buildroot prefix from filelists
perl -pi -e 's,(^| )%{buildroot},\1,' *.files

# Man pages can be compressed
perl -pi -e 's|(^%{_mandir}/man.*$)|\1\*|' *.files

#==========================================
%post -p /sbin/ldconfig -n tcl
%post -p /sbin/ldconfig -n tk
%post -p /sbin/ldconfig -n expect
%post -p /sbin/ldconfig -n tclx
%post -p /sbin/ldconfig -n tix
%post -p /sbin/ldconfig -n itcl
%post -p /sbin/ldconfig -n tcllib

%postun -p /sbin/ldconfig -n tcl
%postun -p /sbin/ldconfig -n tk
%postun -p /sbin/ldconfig -n expect
%postun -p /sbin/ldconfig -n tclx
%postun -p /sbin/ldconfig -n tix
%postun -p /sbin/ldconfig -n itcl
%postun -p /sbin/ldconfig -n tcllib

%clean
rm -rf %{buildroot}
rm -f *.files

%files -f tcl.files -n tcl
%files -f tcl-devel.files -n tcl-devel
%files -f tk.files -n tk
%files -f tk-devel.files -n tk-devel
%files -f tclx.files -n tclx
%files -f expect.files -n expect
%files -f expect-devel.files -n expect-devel
%files -f expectk.files -n expectk
%files -f tix.files -n tix
%files -f itcl.files -n itcl
%files -f tcllib.files -n tcllib
%files -n tcl-html
%defattr(-,root,root)
%doc tcl%{tcltkvers}/html

%changelog
* Mon Jun 28 2004 Jens Petersen <petersen@redhat.com> - 8.3.5-92.2
- fix expect use-after-free segfault with expect-5.38-free-segfault-58317.patch
  (Jonathan Kamens, Bernd Schmidt, 113218)
- backport the following changes to 8.3.5-92:

* Mon Mar 29 2004 Jens Petersen <petersen@redhat.com> - 8.3.5-96
- add expect-ro-afs-112174.patch (Bernd Schmidt,#112174)
- add backward compatibility symlinks /usr/lib/tcl8.3 and /usr/lib/tk8.3

* Fri Jan 16 2004 Jens Petersen <petersen@redhat.com> - 8.3.5-95
- buildrequire autoconf213 (#110583, mvd@mylinux.com.ua)

* Mon Nov 17 2003 Thomas Woerner <twoerner@redhat.com> 8.3.5-94
- fixed RPATH for expect and expectk with expect-5.39.0-libdir.patch

* Wed Oct 15 2003 Jens Petersen <petersen@redhat.com>
- update tix url (#101721) [reported by support@internetdiscovery.com]

* Wed Sep 17 2003 Matt Wilson <msw@redhat.com> 8.3.5-92
- rebuild again for #91211

* Wed Sep 17 2003 Matt Wilson <msw@redhat.com> 8.3.5-91
- rebuild to fix gzipped file md5sums (#91211)

* Fri Jul 04 2003 Jens Petersen <petersen@redhat.com> - 8.3.5-90
- split out devel files from tcl and tk into -devel subpackages (#90087)
- make sure expect and itcl are linked against buildroot not installroot libs
  - add itcl3.2-tclstubs-cfg.patch so that itcl can find tclstubs in buildroot
- fix tcl package path in tclConfig.sh to point to datadir (#90160)
  [reported by Michal Jaegermann]
- remove gratuitous whitespace in koi8-u.enc (#88806)
  [reported with fix by Victor Cheburkin]
- update ucs4 patch to also change regcustom.h, but disable it for now (#89098)

* Fri Mar 21 2003 Jens Petersen <petersen@redhat.com> - 8.3.5-89
- install tix pkgIndex under libdir and let it use datadir for WmDefault
  (#83662 and partly #45570)
- build requires XFree86-devel and tk requires XFree86-libs (#84343)

* Thu Feb  6 2003 Jens Petersen <petersen@redhat.com> - 8.3.5-88
- use ucs4 wide chars since python now does (tkinter)
- remove .cvsignore files from tix docs

* Tue Jan 28 2003 Jens Petersen <petersen@redhat.com> - 8.3.5-87
- bring back expect alpha patch, renamed to 64bit patch (#82547)

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Fri Jan 17 2003 Jens Petersen <petersen@redhat.com> - 8.3.5-85
- install tix library files under datadir
- fix dangling iwidgets symlink in libdir
- build all except tclx with _smp_mflags
- add some requires

* Tue Jan 14 2003 Jens Petersen <petersen@redhat.com> - 8.3.5-84
- link all libs with DT_SONAME using tcl.m4 patch (#81297)
- drop synthetic lib provides
- update tix to 8.1.4
- include tix docs (part of #72497), except the pdf files
- revert to itcl3.2 due to 3.2.1 config problems
- fix iwidget libdir symlink
- install iwidget scripts under datadir
- remove obsolete patches from srpm
- update buildrequires
- use buildroot instead of RPM_BUILD_ROOT
- install all man pages under mandir, instead of moving some from /usr/man
- install libtcl and libtk mode 755
- introduce _genfilelist macro for clean single-sweep find filelist generation
  for each package
- use perl to remove buildroot prefix from filelists

* Thu Jan  9 2003 Jeff Johnson <jbj@redhat.com> 8.3.5-82
- synthesize libtix.so.0 and libtk.so.0 soname dependencies.

* Wed Jan  8 2003 Tim Powers <timp@redhat.com> 8.3.5-81
- rebuild

* Tue Jan  7 2003 Jeff Johnson <jbj@redhat.com> 8.3.5-80
- rebuild to generate deps for4 DSO's w/o DT_SONAME correctly.

* Sat Jan  4 2003 Jeff Johnson <jbj@redhat.com> 8.3.5-79
- set execute bits on library so that requires are generated.

* Tue Dec 10 2002 Jens Petersen <petersen@redhat.com> 8.3.5-78
- make lib symlinks to .so not .so.0

* Tue Dec 10 2002 Jens Petersen <petersen@redhat.com> 8.3.5-77
- build and install tclx with _libdir (not libdir!)
- fix summary-not-capitalized for tclx, tcllib, tcl-html
- fix dangling symlinks (wish, libitcl, libitk)
- define tcllib_major
- generate tix datadir filelist only from datadir

* Mon Dec  9 2002 Jens Petersen <petersen@redhat.com> 8.3.5-76
- make it build on x86_64 (details below)
- add itcl_major and use it
- add 100 to expect patches
- patch expect configure to get EXP_LIB_SPEC to use libdir
- patch tix so it can find itcl-3.2.1 config files
- don't explicitly update config.{guess,sub} since %%configure does it for us
- added "--without check" rpmbuild option to disable running tests in future
- build and install tcl and tk with script files under datadir (not libdir)
- build and install tclx and tkx with INST_RUNTIME files under datadir, and
  EXEC_RUNTIME file under libdir
- build and install itcl with library files under datadir
- build tix after itcl, and actually config, build and install tix itcl library
- install tcllib package files under datadir
- generate filelists from datadir and not from mandir from now on
- install tix binary libraries in libdir

* Tue Dec  3 2002 Jens Petersen <petersen@redhat.com>
- update to tcl-8.3.5, tk-8.3.5, tcl-html-8.3.5
- update url for tcl, tk, tclx, itcl, tcllib
- build without all makecfg patches for now
  - in particular use upstream versioned library name convention
- add backward compatible lib symlinks for now
- add unversioned symlinks for versioned bindir files
- don't apply obsolete tix dirtree patch any more (#45570)
- set tix to epoch 1, since 8.1.3 < 8.2.0b1
- add SC_PATH_TCLCONFIG to fix tcllib configure and run autoconf
- build shared tix libs
- use make's -C option rather than jumping in and out of source dirs
  during install
- use INSTALL_ROOT destdir-like make variable instead of makeinstall
  for all subpackages except tix and itcl
- don't need to move itcl and tcllib man pages downunder datadir
- include all tix files in manifest (#72497)

* Mon Oct 21 2002 Jens Petersen <petersen@redhat.com>
- update to tcl-8.3.4, tk-8.3.4 (#75600), tcllib-1.3, itcl-3.2.1,
  tix-8.1.3 (#59098)
- drop obsolete tcl cruft, tcl refcount, tix perf patches
- move expectk and expect-devel files out of expect into separate packages
  (#9832)
- fix autopasswd on passwords starting with a hyphen (#9917)
- added tcltk html manual
- drop the crud compat dir symlinks in libdir
- correct expect license
- package now builds without tcl or tk installed (partly #52606)
  - replace all relative paths by absolutes ones, using new tcltktop
  - give absolute paths to tcl and tk when configuring
  - give buildroot bindir path to tcllib make
  - export buildroot libdir in LD_LIBRARY_PATH when installing
- move tclx HELP_DIR fix to separate patch
- replace tclvers and tkvers by tcltkvers and use it
- replace tcl_major and tk_major by tcltk_major and use it
- don't explicitly provide 64bit libs on ia64 and sparc64
- drop obsolete tix perf patch (#59098)
- fix itcl build config tk search path and run autoconf
- update tix build steps for 8.1.3
- no longer build obsolete separate itclsh and itkwish

* Tue Aug 20 2002 Jens Petersen <petersen@redhat.com> 8.3.3-74
- fix compat symlink from /usr/lib/expect (#71606)

* Wed Aug 14 2002 Jens Petersen <petersen@redhat.com> 8.3.3-73
- update to expect spawn patch from hjl@gnu.org (bug 43310)

* Tue Aug 13 2002 Jens Petersen <petersen@redhat.com> 8.3.3-72
- update expect to 5.38.0
- fixes #71113 (reported by yarnall@lvc.edu)

* Wed Aug 7 2002 Jens Petersen <petersen@redhat.com> 8.3.3-71
- let wish install as wish8.3, but hardlink it to wish (#69986)

* Sat Jul 20 2002 Akira TAGOH <tagoh@redhat.com> 8.3.3-70
- tclx-8.3-nonstrip.patch: applied to fix the stripped binary issue.

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Wed Jan 09 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Mon Jan 07 2002 Florian La Roche <Florian.LaRoche@redhat.de>
- quick hack to have a correct setpgrp() call in expect
- fix config.guess and config.sub to newer versions

* Mon Aug 29 2001 Adrian Havill <havill@redhat.com>
- hard-coded the compat symlink for tix libdir. (bug 52812)

* Mon Aug 28 2001 Adrian Havill <havill@redhat.com>
- fixed itkwish/itclsh lib problem (bug 52608)
- make itcl install not need tclsh/wish during config/make (bug 52606)
- expect's fixline1 busted for expectk scripts (tkpasswd/tknewsbiff/tkterm)

* Mon Aug  8 2001 Adrian Havill <havill@redhat.com>
- changed rev for tcllib to 1.0
- added execute bit mode for itclsh and itksh compat shells
- re-enable glibc string and math inlines; recent gcc is a-ok.
- optimize at -O2 instead of -O
- rename "soname" patches related to makefile/autoconf changes
- added elf "needed" for tk, tclx, tix, itk
- removed warnings from tclX

* Wed Jul 25 2001 Adrian Havill <havill@redhat.com>
- added itclsh/itkwish for backwards compatibility, fixed rpath (bug 46086)
- fixed 64 bit RPM provides for dependencies

* Thu Jul 19 2001 Adrian Havill <havill@redhat.com>
- updated tclX to the latest version
- fixed tclX 8.3's busted help install
- eliminated make TK_LIB kludge for multiple math libs for tclX
- used %%makeinstall to brute force fix any remaining unflexible makefile dirs
- fixed bad ref count release in tcl (bug 49406)
- improved randomness of expect's mkpasswd script via /dev/random (bug 9507)
- revert --enable-threads, linux is (still) not ready (yet) (bug 49251)
- fixed DirTree in Tix (bug 45570)

* Sun Jul  8 2001 Adrian Havill <havill@redhat.com>
- refresh all sources to latest stable (TODO: separate expect/expectk)
- massage out some build stuff to patches (TODO: libtoolize hacked constants)
- remove patches already rolled into the upstream
- remove unneeded autopasswd
- removed RPATH (bugs 45569, 46085, 46086), added SONAMEs to ELFs
- changed shared object filenames to something less gross
- fixed tclX shell's argv parsing (bug 47710)
- reenable threads which seem to work now
- added all necessary header files for itcl (bug 41374)
- fixed spawn/eof read problem with expect (bug 43310)
- made compile-friendly for IA64

* Sun Jun 24 2001 Elliot Lee <sopwith@redhat.com>
- Bump release + rebuild for 7.2.

* Fri Mar 23 2001 Bill Nottingham <notting@redhat.com>
- bzip2 sources

* Mon Mar 19 2001 Bill Nottingham <notting@redhat.com>
- build with -D_GNU_SOURCE - fixes expect on ia64

* Mon Mar 19 2001 Preston Brown <pbrown@redhat.com>
- build fix from ahavill.

* Wed Feb 21 2001 Tim Powers <timp@redhat.com>
- fixed weather expect script using wrong server (#28505)

* Tue Feb 13 2001 Adrian Havill <havill@redhat.com>
- added "ja_JP.eucJP" to locale list for tcl

* Tue Feb 13 2001 Adrian Havill <havill@redhat.com>
- rebuild so make check passes

* Fri Oct 20 2000 Than Ngo <than@redhat.com>
- rebuild with -O0 on alpha (bug #19461)

* Thu Aug 17 2000 Jeff Johnson <jbj@redhat.com>
- summaries from specspo.

* Tue Aug  8 2000 Florian La Roche <Florian.LaRoche@redhat.de>
- remove symlink to libtixsam.so

* Thu Aug  3 2000 Jeff Johnson <jbj@redhat.com>
- merge "best known" patches from searching, stubs were broken.
- tix needs -fwritable-strings (#14352).
- create tixwish symlink.

* Thu Jul 27 2000 Jeff Johnson <jbj@redhat.com>
- rebuild against "working" util-linux col.

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Fri Jun 16 2000 Jeff Johnson <jbj@redhat.com>
- make sure that tix shared libraries are installed.
- don't mess with %%{_libdir}, it's gonna be a FHS pita.

* Sat Jun 10 2000 Jeff Johnson <jbj@redhat.com>
- move, not symlink, unix/tk8.0 to generate Tix pkgIndex.tcl correctly (#11940).

* Tue Jun  6 2000 Jeff Johnson <jbj@redhat.com>
- tclX had wrong version.

* Fri Jun  2 2000 Jeff Johnson <jbj@redhat.com>
- FHS packaging changes.
- revert --enable-threads, linux is not ready (yet) (#11789).
- tcl/tk: update to 8.3.1 (#10779).
- expect: update to 5.31.7+ (#11595).
- add tcllib-0.4.
- abstract major tcltk version for soname expansion etc.

* Sat Mar 18 2000 Jeff Johnson <jbj@redhat.com>
- update to (tcl,tk}-8.2.3, expect-5.31, and itcl-3.1.0, URL's as well.
- use perl to drill out pre-pended RPM_BUILD_ROOT.
- configure with --enable-threads (experimental).
- improved version of autopasswd (#4788).
- autopasswd needs to handle password starting with hyphen (#9917).
- handle 553 ftp status in rftp expect script (#7869).
- remove cryptdir/decryptdir, as Linux has not crypt command (#6668).
- correct hierarchy spelling (#7082).
- fix "expect -d ...", format string had int printed as string (#7775).

* Tue Mar  7 2000 Jeff Johnson <jbj@redhat.com>
- rebuild for sparc baud rates > 38400.

* Mon Feb  7 2000 Bill Nottingham <notting@redhat.com>
- handle compressed manpages

* Thu Feb 03 2000 Elliot Lee <sopwith@redhat.com>
- Make changes from bug number 7602
- Apply patch from bug number 7537
- Apply fix from bug number 7157
- Add fixes from bug #7601 to the runtcl patch

* Wed Feb 02 2000 Cristian Gafton <gafton@redhat.com>
- fix descriptions
- man pages are compressed (whatapain)

* Tue Nov 30 1999 Jakub Jelinek <jakub@redhat.com>
- fix tclX symlinks.
- compile on systems where SIGPWR == SIGLOST.

* Sat May  1 1999 Jeff Johnson <jbj@redhat.com>
- update tcl/tk to 8.0.5.
- avoid "containing" in Tix (#2332).

* Thu Apr  8 1999 Jeff Johnson <jbj@redhat.com>
- use /usr/bin/write in kibitz (#1320).
- use cirrus.sprl.umich.edu in weather (#1926).

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 28)

* Mon Mar 08 1999 Preston Brown <pbrown@redhat.com>
- whoops, exec-prefix for itcl was set to '/foo', changed to '/usr'.

* Tue Feb 16 1999 Jeff Johnson <jbj@redhat.com>
- expect does unaligned access on alpha (#989)
- upgrade tcl/tk/tclX to 8.0.4
- upgrade expect to 5.28.
- add itcl 3.0.1

* Tue Jan 12 1999 Cristian Gafton <gafton@redhat.com>
- call libtoolize to allow building on the arm
- build for glibc 2.1
- strip binaries

* Thu Sep 10 1998 Jeff Johnson <jbj@redhat.com>
- update tcl/tk/tclX to 8.0.3, expect is updated also.

* Mon Jun 29 1998 Jeff Johnson <jbj@redhat.com>
- expect: mkpasswd needs delay before sending password (problem #576)

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- fixed expect binaries exec permissions

* Thu Apr 09 1998 Erik Troan <ewt@redhat.com>
- updated to Tix 4.1.0.006
- updated version numbers of tcl/tk to relflect includsion of p2

* Wed Mar 25 1998 Cristian Gafton <gafton@redhat.com>
- updated tcl/tk to patch level 2
- updated tclX to 8.0.2

* Thu Oct 30 1997 Otto Hammersmith <otto@redhat.com>
- fixed filelist for tix... replacing path to the expect binary in scripts
  was leaving junk files around.

* Wed Oct 22 1997 Otto Hammersmith <otto@redhat.com>
- added patch to remove libieee test in configure.in for tcl and tk.
  Shoudln't be needed anymore for glibc systems, but this isn't the "proper" 
  solution for all systems
- fixed src urls

* Mon Oct 06 1997 Erik Troan <ewt@redhat.com>
- removed version numbers from descriptions

* Mon Sep 22 1997 Erik Troan <ewt@redhat.com>
- updated to tcl/tk 8.0 and related versions of packages

* Tue Jun 17 1997 Erik Troan <ewt@redhat.com>
- built against glibc
- fixed dangling tclx/tkx symlinks
